/*
 * 2pc.h
 *
 * Header file for 2pc library and daemon.
 * -Dave Lowell
 */

#ifndef TWOPHASE__H
#define TWOPHASE__H

/**
 ** Defines
 **/

/*
 * Although the sample client program in the 2pc distribution takes the
 * hostname of the machine running 2pcd on the command line, Discount
 * Checking references the hardcoded IP of the 2pcd host in the macro
 * SERVER_IP. If you're running Discount Checking with two-phase commit, 
 * remember to change the SERVER_IP macro to reflect your environment.
 */
#define SERVER_IP       0x6f08d58d /* host 'vista.eecs.umich.edu' */
#define SERVER_PORT	8050
#define SIG_PORT	8051

#define MAX_HOSTS	16
#define MAX_TRANS	65536
#define MAX_DEFERRED	128

#define TIMEOUT		1

/* msg and vote types */
#define UNKNOWN		0
#define DO_PREPARE 	1
#define PREPARED 	2
#define COMMIT 		3
#define ABORT 		4

#define REGISTER	10
#define REGISTERED	11
#define DEREGISTER	20
#define DEREGISTERED	21

#define TRUE 		1
#define FALSE 		0

/**
 ** Types
 **/

typedef struct {
	int	type;
	int	id;
	int	aborted;
	int	new_id;
} msg;

typedef struct {
	int	final_vote;
	char	votes[MAX_HOSTS];
} commit_state;

#endif

